<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/PTree/Encoding.hh.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/PTree/Encoding.hh</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/PTree/Encoding.hh</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="comment">//</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="comment">// Copyright (C) 1997 Shigeru Chiba</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="comment">// Copyright (C) 2004 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="comment">// All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="comment">// Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="comment">// see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="comment">//</span></span>
<a id="line8"></a><span class="lineno">  8</span><span class="line">#ifndef Synopsis_PTree_Encoding_hh_</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line">#define Synopsis_PTree_Encoding_hh_</span>
<a id="line10"></a><span class="lineno"> 10</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line">#include &lt;string&gt;</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line">#include &lt;iostream&gt;</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line">#include &lt;cassert&gt;</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line">#include &lt;cstring&gt;</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line">#include &lt;cstdio&gt; // for EOF</span>
<a id="line16"></a><span class="lineno"> 16</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="keyword">namespace</span> Synopsis</span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line">{</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis/PTree.html" title="namespace Synopsis::PTree">PTree</a></span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">{</span>
<a id="line21"></a><span class="lineno"> 21</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">class Node;</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">class Atom;</span>
<a id="line24"></a><span class="lineno"> 24</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line"><span class="comment">//. An Encoding represents a mangled (type) name. Here is a quick reference of the grammar:</span></span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line"><span class="comment">//.</span></span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line"><span class="comment">//. - `b`: boolean</span></span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line"><span class="comment">//. - `c`: char</span></span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line"><span class="comment">//. - `w`: wchar_t</span></span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line"><span class="comment">//. - `i`: int (signed, unsigned)</span></span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line"><span class="comment">//. - `s`: short (short int)</span></span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line"><span class="comment">//. - `l`: long (long int)</span></span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line"><span class="comment">//. - `j`: long long</span></span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line"><span class="comment">//. - `f`: float</span></span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line"><span class="comment">//. - `d`: double</span></span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line"><span class="comment">//. - `r`: long double</span></span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line"><span class="comment">//. - `v`: void</span></span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line"><span class="comment">//. - `T`: template class (e.g. `Foo&lt;int,char&gt;` ==&gt; `T[3]Foo[2]ic`.  `[2]` means</span></span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line"><span class="comment">//.   the length of `ic`.  It doesn't mean the number of template arguments.</span></span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line"><span class="comment">//.</span></span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line"><span class="comment">//. - `e`: ...</span></span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line"><span class="comment">//. - `?`: no return type.  the return type of constructors</span></span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line"><span class="comment">//. - `*`: non-type template parameter</span></span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line"><span class="comment">//.</span></span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line"><span class="comment">//. - `S`: `signed`</span></span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line"><span class="comment">//. - `U`: `unsigned`</span></span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line"><span class="comment">//. - `C`: `const`</span></span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line"><span class="comment">//. - `V`: `volatile`</span></span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line"><span class="comment">//.</span></span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line"><span class="comment">//. - `P`: pointer</span></span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line"><span class="comment">//. - `R`: reference</span></span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line"><span class="comment">//. - `A`: array (e.g. `char[16]` ==&gt; `A16_c`)</span></span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line"><span class="comment">//. - `F`: function (e.g. `char foo(int)` ==&gt; `Fi_c`)</span></span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line"><span class="comment">//. - `M`: pointer to member (e.g. `Type::*` ==&gt; `M[4]Type`)</span></span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line"><span class="comment">//.</span></span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line"><span class="comment">//. - `Q`: qualified class (e.g. `X::YY` ==&gt; `Q[2][1]X[2]YY`, `::YY` ==&gt; `Q[2][0][2]YY`)</span></span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line"><span class="comment">//.</span></span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line"><span class="comment">//. - `[x]`: means `0x80 + x`</span></span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line"><span class="comment">//. - `0`: means `::` (global scope)</span></span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line"><span class="comment">//.</span></span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line"><span class="comment">//. Special function names:</span></span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line"><span class="comment">//.</span></span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line"><span class="comment">//. - operator + ==&gt; +</span></span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line"><span class="comment">//. - operator new[] ==&gt; new[]</span></span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line"><span class="comment">//. - operator &lt;type&gt; ==&gt; @&lt;encoded type&gt;		cast operator</span></span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line"><span class="comment">//.</span></span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> </span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">{</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">  <span class="keyword">struct</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html" title="struct Synopsis::PTree::Encoding::char_traits">char_traits</a></span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">  {</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">    <span class="keyword">typedef</span> <span class="keyword">unsigned char</span>  <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a>;</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">    <span class="keyword">typedef</span> <span class="keyword">unsigned long</span>  <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#int_type" title="typedef Synopsis::PTree::Encoding::char_traits::int_type">int_type</a>;</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">    <span class="keyword">typedef</span> <a href="" title="typedef std::streampos">std::streampos</a> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#pos_type" title="typedef Synopsis::PTree::Encoding::char_traits::pos_type">pos_type</a>;</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">    <span class="keyword">typedef</span> <a href="" title="typedef std::streamoff">std::streamoff</a> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#off_type" title="typedef Synopsis::PTree::Encoding::char_traits::off_type">off_type</a>;</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">    <span class="keyword">typedef</span> <a href="" title="using std::mbstate_t">std::mbstate_t</a> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#state_type" title="typedef Synopsis::PTree::Encoding::char_traits::state_type">state_type</a>;</span>
<a id="line77"></a><span class="lineno"> 77</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">    static <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#assign_lchar_type_A_cconst.char_type_A_r" title="member function Synopsis::PTree::Encoding::char_traits::assign(char_type&amp;,const char_type&amp;)">assign</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> &amp;c1, <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> &amp;c2) { <a href="" title="parameter c1">c1</a> = <a href="" title="parameter c2">c2</a>;}</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">    static <span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#eq_lconst.char_type_A_cconst.char_type_A_r" title="member function Synopsis::PTree::Encoding::char_traits::eq(const char_type&amp;,const char_type&amp;)">eq</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> &amp;c1, <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> &amp;c2) { <span class="keyword">return</span> <a href="" title="parameter c1">c1</a> == <a href="" title="parameter c2">c2</a>;}</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">    static <span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#lt_lconst.char_type_A_cconst.char_type_A_r" title="member function Synopsis::PTree::Encoding::char_traits::lt(const char_type&amp;,const char_type&amp;)">lt</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> &amp;c1, <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> &amp;c2) { <span class="keyword">return</span> <a href="" title="parameter c1">c1</a> &lt; <a href="" title="parameter c2">c2</a>;}</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">    static <span class="keyword">int</span> <a href="" title="member function Synopsis::PTree::Encoding::char_traits::compare(const char_type*,const char_type*,std::size_t)">compare</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> *s1, <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> *s2, <a href="" title="using std::size_t">std::size_t</a> n) { <span class="keyword">return</span> <a href="" title="function memcmp(const void*,const void*,size_t)">memcmp</a>(<a href="" title="parameter s1">s1</a>, <a href="" title="parameter s2">s2</a>, <a href="" title="parameter n">n</a>);}</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">    static <a href="" title="using std::size_t">std::size_t</a> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#length_lconst.char_type_S_r" title="member function Synopsis::PTree::Encoding::char_traits::length(const char_type*)">length</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> *s) { <span class="keyword">return</span> <a href="" title="function strlen(const char*)">strlen</a>((<span class="keyword">const</span> <span class="keyword">char</span> *)<a href="" title="parameter s">s</a>);}</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">    static <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> *<a href="" title="member function Synopsis::PTree::Encoding::char_traits::find(const char_type*,std::size_t,const char_type&amp;)">find</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> *s, <a href="" title="using std::size_t">std::size_t</a> n, <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> &amp;a)</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">    { <span class="keyword">return</span> static_cast&lt;const char_type *&gt;(<a href="" title="function memchr(const void*,int,size_t)">memchr</a>(<a href="" title="parameter s">s</a>, <a href="" title="parameter a">a</a>, <a href="" title="parameter n">n</a>));}</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">    static <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> *<a href="" title="member function Synopsis::PTree::Encoding::char_traits::move(char_type*,const char_type*,std::size_t)">move</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> *s1, <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> *s2, <a href="" title="using std::size_t">std::size_t</a> n)</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">    { <span class="keyword">return</span> static_cast&lt;char_type *&gt;(<a href="" title="function memmove(void*,const void*,size_t)">memmove</a>(<a href="" title="parameter s1">s1</a>, <a href="" title="parameter s2">s2</a>, <a href="" title="parameter n">n</a>));}</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">    static <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> *<a href="" title="member function Synopsis::PTree::Encoding::char_traits::copy(char_type*,const char_type*,std::size_t)">copy</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> *s1, <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> *s2, <a href="" title="using std::size_t">std::size_t</a> n)</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">    { <span class="keyword">return</span> static_cast&lt;char_type *&gt;(<a href="" title="function memcpy(void*,const void*,size_t)">memcpy</a>(<a href="" title="parameter s1">s1</a>, <a href="" title="parameter s2">s2</a>, <a href="" title="parameter n">n</a>));}</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">    static <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> *<a href="" title="member function Synopsis::PTree::Encoding::char_traits::assign(char_type*,std::size_t,char_type)">assign</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> *s, <a href="" title="using std::size_t">std::size_t</a> n, <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> a)</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">    { <span class="keyword">return</span> static_cast&lt;char_type *&gt;(<a href="" title="function memset(void*,int,size_t)">memset</a>(<a href="" title="parameter s">s</a>, <a href="" title="parameter a">a</a>, <a href="" title="parameter n">n</a>));}</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">    static <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#to_char_type_lconst.int_type_A_r" title="member function Synopsis::PTree::Encoding::char_traits::to_char_type(const int_type&amp;)">to_char_type</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#int_type" title="typedef Synopsis::PTree::Encoding::char_traits::int_type">int_type</a> &amp;c) { <span class="keyword">return</span> static_cast&lt;char_type&gt;(<a href="" title="parameter c">c</a>);}</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">    static <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#int_type" title="typedef Synopsis::PTree::Encoding::char_traits::int_type">int_type</a> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#to_int_type_lconst.char_type_A_r" title="member function Synopsis::PTree::Encoding::char_traits::to_int_type(const char_type&amp;)">to_int_type</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#char_type" title="typedef Synopsis::PTree::Encoding::char_traits::char_type">char_type</a> &amp;c) { <span class="keyword">return</span> static_cast&lt;int_type&gt;(<a href="" title="parameter c">c</a>);}</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">    static <span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#eq_int_type_lconst.int_type_A_cconst.int_type_A_r" title="member function Synopsis::PTree::Encoding::char_traits::eq_int_type(const int_type&amp;,const int_type&amp;)">eq_int_type</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#int_type" title="typedef Synopsis::PTree::Encoding::char_traits::int_type">int_type</a> &amp;c1, <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#int_type" title="typedef Synopsis::PTree::Encoding::char_traits::int_type">int_type</a> &amp;c2) { <span class="keyword">return</span> <a href="" title="parameter c1">c1</a> == <a href="" title="parameter c2">c2</a>;}</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">    static <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#int_type" title="typedef Synopsis::PTree::Encoding::char_traits::int_type">int_type</a> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#eof_l_r" title="member function Synopsis::PTree::Encoding::char_traits::eof()">eof</a>() { <span class="keyword">return</span> static_cast&lt;int_type&gt;(<a href="" title="macro call">EOF</a>);}</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">    static <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#int_type" title="typedef Synopsis::PTree::Encoding::char_traits::int_type">int_type</a> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#not_eof_lconst.int_type_A_r" title="member function Synopsis::PTree::Encoding::char_traits::not_eof(const int_type&amp;)">not_eof</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#int_type" title="typedef Synopsis::PTree::Encoding::char_traits::int_type">int_type</a> &amp;c) { <span class="keyword">return</span> !<a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#eq_int_type_lconst.int_type_A_cconst.int_type_A_r" title="member function Synopsis::PTree::Encoding::char_traits::eq_int_type(const int_type&amp;,const int_type&amp;)">eq_int_type</a>(<a href="" title="parameter c">c</a>, <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#eof_l_r" title="member function Synopsis::PTree::Encoding::char_traits::eof()">eof</a>()) ? <a href="" title="parameter c">c</a> : <a href="../../../Scopes/Synopsis/PTree/Encoding/char_traits.html#to_int_type_lconst.char_type_A_r" title="member function Synopsis::PTree::Encoding::char_traits::to_int_type(const char_type&amp;)">to_int_type</a>(char_type());}</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">  };</span>
<a id="line97"></a><span class="lineno"> 97</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">  <span class="keyword">typedef</span> std::<a href="" title="class std::basic_string">basic_string</a>&lt;<span class="keyword">unsigned char</span>, char_traits&gt; <a href="../../../Scopes/Synopsis/PTree/Encoding.html#Code" title="typedef Synopsis::PTree::Encoding::Code">Code</a>;</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">  <span class="keyword">typedef</span> Code::const_iterator <a href="../../../Scopes/Synopsis/PTree/Encoding.html#iterator" title="typedef Synopsis::PTree::Encoding::iterator">iterator</a>;</span>
<a id="line100"></a><span class="lineno">100</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">  static <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#do_init_static_l_r" title="member function Synopsis::PTree::Encoding::do_init_static()">do_init_static</a>();</span>
<a id="line102"></a><span class="lineno">102</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Encoding.html#Encoding_l_r" title="member function Synopsis::PTree::Encoding::Encoding()">Encoding</a>() {}</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Encoding.html#Encoding_lconst.Code_A_r" title="member function Synopsis::PTree::Encoding::Encoding(const Code&amp;)">Encoding</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#Code" title="typedef Synopsis::PTree::Encoding::Code">Code</a> &amp;b) : my_buffer(b) {}</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Encoding.html#Encoding_lconst.char_S_r" title="member function Synopsis::PTree::Encoding::Encoding(const char*)">Encoding</a>(<span class="keyword">const</span> <span class="keyword">char</span> *b) : my_buffer(b, b + strlen(b)) {}</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Encoding.html#Encoding_lconst.char_S_csize_t_r" title="member function Synopsis::PTree::Encoding::Encoding(const char*,size_t)">Encoding</a>(<span class="keyword">const</span> <span class="keyword">char</span> *b, <a href="" title="typedef size_t">size_t</a> s) : my_buffer(b, b + s) {}</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Encoding.html#Encoding_literator_citerator_r" title="member function Synopsis::PTree::Encoding::Encoding(iterator,iterator)">Encoding</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html#iterator" title="typedef Synopsis::PTree::Encoding::iterator">iterator</a> b, <a href="../../../Scopes/Synopsis/PTree/Encoding.html#iterator" title="typedef Synopsis::PTree::Encoding::iterator">iterator</a> e) : my_buffer(b, e) {}</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">  static <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#simple_name_lconst.Atom_S_r" title="member function Synopsis::PTree::Encoding::simple_name(const Atom*)">simple_name</a>(<a href="../../../Scopes/Synopsis/PTree/Atom.html" title="class Synopsis::PTree::Atom">PTree::Atom const</a> *name);</span>
<a id="line109"></a><span class="lineno">109</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#clear_l_r" title="member function Synopsis::PTree::Encoding::clear()">clear</a>() { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>.<a href="" title="member function std::basic_string::clear()">clear</a>();}</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">  <span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#empty_l_rconst" title="member function Synopsis::PTree::Encoding::empty()const">empty</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>.<a href="" title="member function std::basic_string::empty()const">empty</a>();}</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">  <a href="" title="typedef size_t">size_t</a> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#size_l_rconst" title="member function Synopsis::PTree::Encoding::size()const">size</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>.<a href="" title="member function std::basic_string::size()const">size</a>();}</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Encoding.html#iterator" title="typedef Synopsis::PTree::Encoding::iterator">iterator</a> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#begin_l_rconst" title="member function Synopsis::PTree::Encoding::begin()const">begin</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>.<a href="" title="member function std::basic_string::begin()">begin</a>();}</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Encoding.html#iterator" title="typedef Synopsis::PTree::Encoding::iterator">iterator</a> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#end_l_rconst" title="member function Synopsis::PTree::Encoding::end()const">end</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>.<a href="" title="member function std::basic_string::end()">end</a>();}</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">  <span class="keyword">unsigned char</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#front_l_rconst" title="member function Synopsis::PTree::Encoding::front()const">front</a>() const { <span class="keyword">return</span> *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#begin_l_rconst" title="member function Synopsis::PTree::Encoding::begin()const">begin</a>();}</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">  <span class="keyword">unsigned char</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#at_lsize_t_rconst" title="member function Synopsis::PTree::Encoding::at(size_t)const">at</a>(<a href="" title="typedef size_t">size_t</a> i) const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>.<a href="" title="member function std::basic_string::at(size_type)const">at</a>(<a href="" title="parameter i">i</a>);}</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">  <span class="comment">//. return a copy of the underlaying buffer</span></span>
<a id="line118"></a><span class="lineno">118</span><span class="line"><span class="comment">  //. FIXME: this is a temporary workaround while there are</span></span>
<a id="line119"></a><span class="lineno">119</span><span class="line"><span class="comment">  //. still places that use raw strings</span></span>
<a id="line120"></a><span class="lineno">120</span><span class="line">  <span class="keyword">const</span> <span class="keyword">char</span> *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#copy_l_rconst" title="member function Synopsis::PTree::Encoding::copy()const">copy</a>() const;</span>
<a id="line121"></a><span class="lineno">121</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">  <span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#operator_e_e_lconst.Encoding_A_rconst" title="member function Synopsis::PTree::Encoding::operator==(const Encoding&amp;)const">operator ==</a> (<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> &amp;e) const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a> == <a href="" title="parameter e">e</a>.<a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>;}</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::PTree::Encoding::operator==(const std::string&amp;)const">operator ==</a> (<span class="keyword">const</span> <a href="" title="typedef std::string">std::string</a> &amp;s) const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a> == (<span class="keyword">const</span> <span class="keyword">unsigned char</span> *)<a href="" title="parameter s">s</a>.c_str();}</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">  <span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#operator_e_e_lconst.char_S_rconst" title="member function Synopsis::PTree::Encoding::operator==(const char*)const">operator ==</a> (<span class="keyword">const</span> <span class="keyword">char</span> *s) const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a> == (<span class="keyword">const</span> <span class="keyword">unsigned char</span> *)<a href="" title="parameter s">s</a>;}</span>
<a id="line125"></a><span class="lineno">125</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#prepend_lunsigned.char_r" title="member function Synopsis::PTree::Encoding::prepend(unsigned char)">prepend</a>(<span class="keyword">unsigned char</span> c) { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>.<a href="" title="member function std::basic_string::insert(iterator,_CharT)">insert</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>.<a href="" title="member function std::basic_string::begin()">begin</a>(), <a href="" title="parameter c">c</a>);}</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#prepend_lconst.char_S_csize_t_r" title="member function Synopsis::PTree::Encoding::prepend(const char*,size_t)">prepend</a>(<span class="keyword">const</span> <span class="keyword">char</span> *p, <a href="" title="typedef size_t">size_t</a> s) { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>.<a href="" title="member function std::basic_string::insert(size_type,const _CharT*,size_type)">insert</a>(<span class="literal">0</span>, (<span class="keyword">const</span> <span class="keyword">unsigned char</span> *)<a href="" title="parameter p">p</a>, <a href="" title="parameter s">s</a>);}</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#prepend_lconst.Encoding_A_r" title="member function Synopsis::PTree::Encoding::prepend(const Encoding&amp;)">prepend</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> &amp;e) { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>.<a href="" title="member function std::basic_string::insert(size_type,const basic_string&amp;)">insert</a>(<span class="literal">0</span>, <a href="" title="parameter e">e</a>.<a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>);}</span>
<a id="line129"></a><span class="lineno">129</span>
<a id="line130"></a><span class="lineno">130</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#append_lunsigned.char_r" title="member function Synopsis::PTree::Encoding::append(unsigned char)">append</a>(<span class="keyword">unsigned char</span> c) { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>.<a href="" title="member function std::basic_string::append(size_type,_CharT)">append</a>(<span class="literal">1</span>, <a href="" title="parameter c">c</a>);}</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#append_lconst.char_S_csize_t_r" title="member function Synopsis::PTree::Encoding::append(const char*,size_t)">append</a>(<span class="keyword">const</span> <span class="keyword">char</span> *p, <a href="" title="typedef size_t">size_t</a> s) { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>.<a href="" title="member function std::basic_string::append(const _CharT*,size_type)">append</a>((<span class="keyword">const</span> <span class="keyword">unsigned char</span> *)<a href="" title="parameter p">p</a>, <a href="" title="parameter s">s</a>);}</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#append_lconst.Encoding_A_r" title="member function Synopsis::PTree::Encoding::append(const Encoding&amp;)">append</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> &amp;e) { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>.<a href="" title="member function std::basic_string::append(const basic_string&amp;)">append</a>(<a href="" title="parameter e">e</a>.<a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>);}</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#append_with_length_lconst.char_S_csize_t_r" title="member function Synopsis::PTree::Encoding::append_with_length(const char*,size_t)">append_with_length</a>(<span class="keyword">const</span> <span class="keyword">char</span> *s, <a href="" title="typedef size_t">size_t</a> n) { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#append_lunsigned.char_r" title="member function Synopsis::PTree::Encoding::append(unsigned char)">append</a>(<span class="literal">0x80</span> + <a href="" title="parameter n">n</a>); <a href="../../../Scopes/Synopsis/PTree/Encoding.html#append_lconst.char_S_csize_t_r" title="member function Synopsis::PTree::Encoding::append(const char*,size_t)">append</a>((<span class="keyword">const</span> <span class="keyword">char</span> *)<a href="" title="parameter s">s</a>, <a href="" title="parameter n">n</a>);}</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#append_with_length_lconst.Encoding_A_r" title="member function Synopsis::PTree::Encoding::append_with_length(const Encoding&amp;)">append_with_length</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> &amp;e) { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#append_lunsigned.char_r" title="member function Synopsis::PTree::Encoding::append(unsigned char)">append</a>(<span class="literal">0x80</span> + <a href="" title="parameter e">e</a>.<a href="../../../Scopes/Synopsis/PTree/Encoding.html#size_l_rconst" title="member function Synopsis::PTree::Encoding::size()const">size</a>()); <a href="../../../Scopes/Synopsis/PTree/Encoding.html#append_lconst.Encoding_A_r" title="member function Synopsis::PTree::Encoding::append(const Encoding&amp;)">append</a>(<a href="" title="parameter e">e</a>);}</span>
<a id="line135"></a><span class="lineno">135</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">  <span class="keyword">unsigned char</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#pop_l_r" title="member function Synopsis::PTree::Encoding::pop()">pop</a>();</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#pop_lsize_t_r" title="member function Synopsis::PTree::Encoding::pop(size_t)">pop</a>(<a href="" title="typedef size_t">size_t</a> n) { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>.<a href="" title="member function std::basic_string::erase(iterator,iterator)">erase</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>.<a href="" title="member function std::basic_string::begin()">begin</a>(), <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>.<a href="" title="member function std::basic_string::begin()">begin</a>() + <a href="" title="parameter n">n</a>);}</span>
<a id="line138"></a><span class="lineno">138</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#cv_qualify_lconst.Node_S_cconst.Node_S_r" title="member function Synopsis::PTree::Encoding::cv_qualify(const Node*,const Node*)">cv_qualify</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> * = 0);</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#simple_const_l_r" title="member function Synopsis::PTree::Encoding::simple_const()">simple_const</a>() { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#append_lconst.char_S_csize_t_r" title="member function Synopsis::PTree::Encoding::append(const char*,size_t)">append</a>(<span class="string">&quot;Ci&quot;</span>, <span class="literal">2</span>);}</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#global_scope_l_r" title="member function Synopsis::PTree::Encoding::global_scope()">global_scope</a>();</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#simple_name_lconst.Node_S_r" title="member function Synopsis::PTree::Encoding::simple_name(const Node*)">simple_name</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#anonymous_l_r" title="member function Synopsis::PTree::Encoding::anonymous()">anonymous</a>();</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#template__lconst.Node_S_cconst.Encoding_A_r" title="member function Synopsis::PTree::Encoding::template_(const Node*,const Encoding&amp;)">template_</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> &amp;);</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#qualified_lint_r" title="member function Synopsis::PTree::Encoding::qualified(int)">qualified</a>(<span class="keyword">int</span>);</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#destructor_lconst.Node_S_r" title="member function Synopsis::PTree::Encoding::destructor(const Node*)">destructor</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line147"></a><span class="lineno">147</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#ptr_operator_lint_r" title="member function Synopsis::PTree::Encoding::ptr_operator(int)">ptr_operator</a>(<span class="keyword">int</span>);</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#ptr_to_member_lconst.Encoding_A_cint_r" title="member function Synopsis::PTree::Encoding::ptr_to_member(const Encoding&amp;,int)">ptr_to_member</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> &amp;, <span class="keyword">int</span>);</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#cast_operator_lconst.Encoding_A_r" title="member function Synopsis::PTree::Encoding::cast_operator(const Encoding&amp;)">cast_operator</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> &amp;);</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#array_l_r" title="member function Synopsis::PTree::Encoding::array()">array</a>() { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#prepend_lconst.char_S_csize_t_r" title="member function Synopsis::PTree::Encoding::prepend(const char*,size_t)">prepend</a>(<span class="string">&quot;A_&quot;</span>, <span class="literal">2</span>);}</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#array_lunsigned.long_r" title="member function Synopsis::PTree::Encoding::array(unsigned long)">array</a>(<span class="keyword">unsigned long</span> s);</span>
<a id="line152"></a><span class="lineno">152</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#function_lconst.Encoding_A_r" title="member function Synopsis::PTree::Encoding::function(const Encoding&amp;)">function</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> &amp;e) { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#prepend_lconst.Encoding_A_r" title="member function Synopsis::PTree::Encoding::prepend(const Encoding&amp;)">prepend</a>(<a href="" title="parameter e">e</a>);}</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#recursion_lconst.Encoding_A_r" title="member function Synopsis::PTree::Encoding::recursion(const Encoding&amp;)">recursion</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> &amp;e) { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#prepend_lconst.Encoding_A_r" title="member function Synopsis::PTree::Encoding::prepend(const Encoding&amp;)">prepend</a>(<a href="" title="parameter e">e</a>);}</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#start_func_args_l_r" title="member function Synopsis::PTree::Encoding::start_func_args()">start_func_args</a>() { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#append_lunsigned.char_r" title="member function Synopsis::PTree::Encoding::append(unsigned char)">append</a>(<span class="string">'F'</span>);}</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#end_func_args_l_r" title="member function Synopsis::PTree::Encoding::end_func_args()">end_func_args</a>() { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#append_lunsigned.char_r" title="member function Synopsis::PTree::Encoding::append(unsigned char)">append</a>(<span class="string">'_'</span>);}</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#void__l_r" title="member function Synopsis::PTree::Encoding::void_()">void_</a>() { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#append_lunsigned.char_r" title="member function Synopsis::PTree::Encoding::append(unsigned char)">append</a>(<span class="string">'v'</span>);}</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#ellipsis_arg_l_r" title="member function Synopsis::PTree::Encoding::ellipsis_arg()">ellipsis_arg</a>() { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#append_lunsigned.char_r" title="member function Synopsis::PTree::Encoding::append(unsigned char)">append</a>(<span class="string">'e'</span>);}</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#no_return_type_l_r" title="member function Synopsis::PTree::Encoding::no_return_type()">no_return_type</a>() { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#append_lunsigned.char_r" title="member function Synopsis::PTree::Encoding::append(unsigned char)">append</a>(<span class="string">'?'</span>);}</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#value_temp_param_l_r" title="member function Synopsis::PTree::Encoding::value_temp_param()">value_temp_param</a>() { <a href="../../../Scopes/Synopsis/PTree/Encoding.html#append_lunsigned.char_r" title="member function Synopsis::PTree::Encoding::append(unsigned char)">append</a>(<span class="string">'*'</span>);}</span>
<a id="line160"></a><span class="lineno">160</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">  <span class="comment">//. if this Encoding represents a qualified name,</span></span>
<a id="line162"></a><span class="lineno">162</span><span class="line"><span class="comment">  //. return the name of the outer scope</span></span>
<a id="line163"></a><span class="lineno">163</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#get_scope_l_rconst" title="member function Synopsis::PTree::Encoding::get_scope()const">get_scope</a>() const;</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">  <span class="comment">//. if this Encoding represents a qualified name,</span></span>
<a id="line165"></a><span class="lineno">165</span><span class="line"><span class="comment">  //. return the name of the symbol inside the outer scope,</span></span>
<a id="line166"></a><span class="lineno">166</span><span class="line"><span class="comment">  //. else return the unmodified name</span></span>
<a id="line167"></a><span class="lineno">167</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#get_symbol_l_rconst" title="member function Synopsis::PTree::Encoding::get_symbol()const">get_symbol</a>() const;</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#get_template_arguments_l_rconst" title="member function Synopsis::PTree::Encoding::get_template_arguments()const">get_template_arguments</a>() const;</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">  </span>
<a id="line170"></a><span class="lineno">170</span><span class="line">  <a href="" title="typedef std::string">std::string</a> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#unmangled_l_rconst" title="member function Synopsis::PTree::Encoding::unmangled()const">unmangled</a>() const;</span>
<a id="line171"></a><span class="lineno">171</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#make_name_l_r" title="member function Synopsis::PTree::Encoding::make_name()">make_name</a>();</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#make_qname_l_r" title="member function Synopsis::PTree::Encoding::make_qname()">make_qname</a>();</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#make_ptree_lNode_S_r" title="member function Synopsis::PTree::Encoding::make_ptree(Node*)">make_ptree</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *);</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">  <span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#is_simple_name_l_rconst" title="member function Synopsis::PTree::Encoding::is_simple_name()const">is_simple_name</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#front_l_rconst" title="member function Synopsis::PTree::Encoding::front()const">front</a>() &gt;= <span class="literal">0x80</span>;}</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">  <span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#is_global_scope_l_rconst" title="member function Synopsis::PTree::Encoding::is_global_scope()const">is_global_scope</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#front_l_rconst" title="member function Synopsis::PTree::Encoding::front()const">front</a>() == <span class="literal">0x80</span> &amp;&amp; <a href="../../../Scopes/Synopsis/PTree/Encoding.html#size_l_rconst" title="member function Synopsis::PTree::Encoding::size()const">size</a>() == <span class="literal">1</span>;}</span>
<a id="line177"></a><span class="lineno">177</span><span class="line">  <span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#is_qualified_l_rconst" title="member function Synopsis::PTree::Encoding::is_qualified()const">is_qualified</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#front_l_rconst" title="member function Synopsis::PTree::Encoding::front()const">front</a>() == <span class="string">'Q'</span>;}</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">  <span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#is_function_l_rconst" title="member function Synopsis::PTree::Encoding::is_function()const">is_function</a>() const;</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">  <span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#is_template_l_rconst" title="member function Synopsis::PTree::Encoding::is_template()const">is_template</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#front_l_rconst" title="member function Synopsis::PTree::Encoding::front()const">front</a>() == <span class="string">'T'</span>;}</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#name_to_ptree_l_r" title="member function Synopsis::PTree::Encoding::name_to_ptree()">name_to_ptree</a>();</span>
<a id="line181"></a><span class="lineno">181</span>
<a id="line182"></a><span class="lineno">182</span><span class="line">  friend <span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#operator_L_lconst.Encoding_A_cconst.Encoding_A_r" title="member function Synopsis::PTree::Encoding::operator&lt;(const Encoding&amp;,const Encoding&amp;)">operator &lt;</a> (<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> &amp;, <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> &amp;);</span>
<a id="line183"></a><span class="lineno">183</span><span class="line">  friend <a href="" title="typedef std::ostream">std::ostream</a> &amp;<a href="" title="member function Synopsis::PTree::Encoding::operator&lt;&lt;(std::ostream&amp;,const Encoding&amp;)">operator &lt;&lt;</a> (<a href="" title="typedef std::ostream">std::ostream</a> &amp;, <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> &amp;);</span>
<a id="line184"></a><span class="lineno">184</span>
<a id="line185"></a><span class="lineno">185</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line186"></a><span class="lineno">186</span>
<a id="line187"></a><span class="lineno">187</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Encoding.html#iterator" title="typedef Synopsis::PTree::Encoding::iterator">iterator</a> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#end_of_scope_l_rconst" title="member function Synopsis::PTree::Encoding::end_of_scope()const">end_of_scope</a>() const;</span>
<a id="line188"></a><span class="lineno">188</span>
<a id="line189"></a><span class="lineno">189</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Encoding.html#Code" title="typedef Synopsis::PTree::Encoding::Code">Code</a> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>;</span>
<a id="line190"></a><span class="lineno">190</span>
<a id="line191"></a><span class="lineno">191</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line192"></a><span class="lineno">192</span><span class="line">  static <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#bool_t" title="data member Synopsis::PTree::Encoding::bool_t">bool_t</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#char_t" title="data member Synopsis::PTree::Encoding::char_t">char_t</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#wchar_t_t" title="data member Synopsis::PTree::Encoding::wchar_t_t">wchar_t_t</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#int_t" title="data member Synopsis::PTree::Encoding::int_t">int_t</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#short_t" title="data member Synopsis::PTree::Encoding::short_t">short_t</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#long_t" title="data member Synopsis::PTree::Encoding::long_t">long_t</a>,</span>
<a id="line193"></a><span class="lineno">193</span><span class="line">		 *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#float_t" title="data member Synopsis::PTree::Encoding::float_t">float_t</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#double_t" title="data member Synopsis::PTree::Encoding::double_t">double_t</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#void_t" title="data member Synopsis::PTree::Encoding::void_t">void_t</a>;</span>
<a id="line194"></a><span class="lineno">194</span>
<a id="line195"></a><span class="lineno">195</span><span class="line">  static <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#signed_t" title="data member Synopsis::PTree::Encoding::signed_t">signed_t</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#unsigned_t" title="data member Synopsis::PTree::Encoding::unsigned_t">unsigned_t</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#const_t" title="data member Synopsis::PTree::Encoding::const_t">const_t</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#volatile_t" title="data member Synopsis::PTree::Encoding::volatile_t">volatile_t</a>;</span>
<a id="line196"></a><span class="lineno">196</span>
<a id="line197"></a><span class="lineno">197</span><span class="line">  static <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#operator_name" title="data member Synopsis::PTree::Encoding::operator_name">operator_name</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#new_operator" title="data member Synopsis::PTree::Encoding::new_operator">new_operator</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#anew_operator" title="data member Synopsis::PTree::Encoding::anew_operator">anew_operator</a>,</span>
<a id="line198"></a><span class="lineno">198</span><span class="line">		 *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#delete_operator" title="data member Synopsis::PTree::Encoding::delete_operator">delete_operator</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#adelete_operator" title="data member Synopsis::PTree::Encoding::adelete_operator">adelete_operator</a>;</span>
<a id="line199"></a><span class="lineno">199</span>
<a id="line200"></a><span class="lineno">200</span><span class="line">  static <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#star" title="data member Synopsis::PTree::Encoding::star">star</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#ampersand" title="data member Synopsis::PTree::Encoding::ampersand">ampersand</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#comma" title="data member Synopsis::PTree::Encoding::comma">comma</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#dots" title="data member Synopsis::PTree::Encoding::dots">dots</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#scope" title="data member Synopsis::PTree::Encoding::scope">scope</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#tilder" title="data member Synopsis::PTree::Encoding::tilder">tilder</a>,</span>
<a id="line201"></a><span class="lineno">201</span><span class="line">		 *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#left_paren" title="data member Synopsis::PTree::Encoding::left_paren">left_paren</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#right_paren" title="data member Synopsis::PTree::Encoding::right_paren">right_paren</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#left_bracket" title="data member Synopsis::PTree::Encoding::left_bracket">left_bracket</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#right_bracket" title="data member Synopsis::PTree::Encoding::right_bracket">right_bracket</a>,</span>
<a id="line202"></a><span class="lineno">202</span><span class="line">		 *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#left_angle" title="data member Synopsis::PTree::Encoding::left_angle">left_angle</a>, *<a href="../../../Scopes/Synopsis/PTree/Encoding.html#right_angle" title="data member Synopsis::PTree::Encoding::right_angle">right_angle</a>;</span>
<a id="line203"></a><span class="lineno">203</span><span class="line">};</span>
<a id="line204"></a><span class="lineno">204</span>
<a id="line205"></a><span class="lineno">205</span><span class="line">inline <span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree.html#operator_L_lconst.Encoding_A_cconst.Encoding_A_r" title="function Synopsis::PTree::operator&lt;(const Encoding&amp;,const Encoding&amp;)">operator &lt;</a> (<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> &amp;e1, <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> &amp;e2) </span>
<a id="line206"></a><span class="lineno">206</span><span class="line">{</span>
<a id="line207"></a><span class="lineno">207</span><span class="line">  <span class="keyword">return</span> <a href="" title="parameter e1">e1</a>.<a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a> &lt; <a href="" title="parameter e2">e2</a>.<a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>;</span>
<a id="line208"></a><span class="lineno">208</span><span class="line">}</span>
<a id="line209"></a><span class="lineno">209</span>
<a id="line210"></a><span class="lineno">210</span><span class="line">inline <a href="" title="typedef std::ostream">std::ostream</a> &amp;<a href="" title="function Synopsis::PTree::operator&lt;&lt;(std::ostream&amp;,const Encoding&amp;)">operator &lt;&lt;</a> (<a href="" title="typedef std::ostream">std::ostream</a> &amp;os, <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">Encoding</a> &amp;e)</span>
<a id="line211"></a><span class="lineno">211</span><span class="line">{</span>
<a id="line212"></a><span class="lineno">212</span><span class="line">  <span class="keyword">for</span> (<a href="../../../Scopes/Synopsis/PTree/Encoding.html#iterator" title="typedef Synopsis::PTree::Encoding::iterator">Encoding::iterator</a> <a href="" title="local variable `for::i">i</a> = <a href="" title="parameter e">e</a>.<a href="../../../Scopes/Synopsis/PTree/Encoding.html#begin_l_rconst" title="member function Synopsis::PTree::Encoding::begin()const">begin</a>();</span>
<a id="line213"></a><span class="lineno">213</span><span class="line">       <a href="" title="local variable `for::i">i</a> != <a href="" title="parameter e">e</a>.<a href="../../../Scopes/Synopsis/PTree/Encoding.html#end_l_rconst" title="member function Synopsis::PTree::Encoding::end()const">end</a>();</span>
<a id="line214"></a><span class="lineno">214</span><span class="line">       ++<a href="" title="local variable `for::i">i</a>)</span>
<a id="line215"></a><span class="lineno">215</span><span class="line">    <span class="keyword">if</span>(*<a href="" title="local variable `for::i">i</a> &lt; <span class="literal">0x80</span>) <a href="" title="parameter os">os</a>.put(static_cast&lt;char&gt;(*<a href="" title="local variable `for::i">i</a>));</span>
<a id="line216"></a><span class="lineno">216</span><span class="line">    <span class="keyword">else</span> <a href="" title="parameter os">os</a> &lt;&lt; <span class="string">'['</span> &lt;&lt; static_cast&lt;int&gt;(*<a href="" title="local variable `for::i">i</a> - <span class="literal">0x80</span>) &lt;&lt; <span class="string">']'</span>;</span>
<a id="line217"></a><span class="lineno">217</span><span class="line">  <span class="keyword">return</span> <a href="" title="parameter os">os</a>;</span>
<a id="line218"></a><span class="lineno">218</span><span class="line">}</span>
<a id="line219"></a><span class="lineno">219</span>
<a id="line220"></a><span class="lineno">220</span><span class="line">inline <span class="keyword">unsigned char</span> <a href="../../../Scopes/Synopsis/PTree/Encoding.html#pop_l_r" title="member function Synopsis::PTree::Encoding::pop()">Encoding::pop</a>() </span>
<a id="line221"></a><span class="lineno">221</span><span class="line">{</span>
<a id="line222"></a><span class="lineno">222</span><span class="line">  <span class="keyword">unsigned char</span> <a href="" title="local variable code">code</a> = <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>[<span class="literal">0</span>]; </span>
<a id="line223"></a><span class="lineno">223</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Encoding.html#my_buffer" title="data member Synopsis::PTree::Encoding::my_buffer">my_buffer</a>.<a href="" title="member function std::basic_string::erase(size_type,size_type)">erase</a>(<span class="literal">0</span>, <span class="literal">1</span>); </span>
<a id="line224"></a><span class="lineno">224</span><span class="line">  <span class="keyword">return</span> <a href="" title="local variable code">code</a>;</span>
<a id="line225"></a><span class="lineno">225</span><span class="line">}</span>
<a id="line226"></a><span class="lineno">226</span>
<a id="line227"></a><span class="lineno">227</span><span class="line">inline bool Encoding::is_function() const </span>
<a id="line228"></a><span class="lineno">228</span><span class="line">{</span>
<a id="line229"></a><span class="lineno">229</span><span class="line">  if (front() == 'F') return true;</span>
<a id="line230"></a><span class="lineno">230</span><span class="line">  // const (member) function.</span>
<a id="line231"></a><span class="lineno">231</span><span class="line">  else if (front() == 'C' &amp;&amp; *(begin() + 1) == 'F') return true;</span>
<a id="line232"></a><span class="lineno">232</span><span class="line">  else return false;</span>
<a id="line233"></a><span class="lineno">233</span><span class="line">}</span>
<a id="line234"></a><span class="lineno">234</span>
<a id="line235"></a><span class="lineno">235</span><span class="line">}</span>
<a id="line236"></a><span class="lineno">236</span><span class="line">}</span>
<a id="line237"></a><span class="lineno">237</span>
<a id="line238"></a><span class="lineno">238</span><span class="line">#endif</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:28:02 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
